export var Point;
(function (Point) {
    const floor = Math.floor;
    function scale(scale, p) {
        return {
            x: floor(p.x * scale.x),
            y: floor(p.y * scale.y)
        };
    }
    Point.scale = scale;
    function scaleConstant(scale, p) {
        return {
            x: floor(p.x * scale),
            y: floor(p.y * scale)
        };
    }
    Point.scaleConstant = scaleConstant;
    function scaleAxis(axis, scale, p) {
        const ret = copy(p);
        ret[axis] = floor(p[axis] * scale);
        return ret;
    }
    Point.scaleAxis = scaleAxis;
    function copy(p) {
        return { x: p.x, y: p.y };
    }
    Point.copy = copy;
    function add(a, b) {
        return {
            x: a.x + b.x,
            y: a.y + b.y
        };
    }
    Point.add = add;
    function subtract(a, b) {
        return {
            x: a.x - b.x,
            y: a.y - b.y
        };
    }
    Point.subtract = subtract;
    Point.ZERO = { x: 0, y: 0 };
    function isPositive(p) {
        return p.x > 0 && p.y > 0;
    }
    Point.isPositive = isPositive;
    function eqTo(p, x, y) {
        return p.x === x && p.y === y;
    }
    Point.eqTo = eqTo;
    function ofEvent(event) {
        const [absx, absy] = event.get_coords();
        return { x: absx, y: absy };
    }
    Point.ofEvent = ofEvent;
    function magnitude(p) {
        return Math.sqrt(Math.pow(p.x, 2) + Math.pow(p.y, 2));
    }
    Point.magnitude = magnitude;
})(Point || (Point = {}));
